import pygtk
pygtk.require('2.0')
import gtk
import ItemWindow

class GUI:	
	def __init__(self, dba):
		self.level = 0
		self.dba = dba
		
        	self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
		self.window.set_title("Stuff")		
		#self.window.get_settings().set_long_property("gtk-button-images",1,)
		
		self.swindow = gtk.ScrolledWindow()
		self.swindow.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
		
		#self.window.fullscreen()
		self.window.connect("destroy", self.destroy)
		
		self.model = gtk.ListStore(str, gtk.gdk.Pixbuf)
		self.model_menu = gtk.ListStore(str, gtk.gdk.Pixbuf)
		
		self.thumb_view = gtk.IconView()
		self.thumb_view.set_selection_mode(gtk.SELECTION_NONE)
		self.thumb_view.set_model(self.model)
		self.thumb_view.set_text_column(0)
		self.thumb_view.set_pixbuf_column(1)
		self.thumb_view.set_columns(-1)
		self.thumb_view.set_item_width(-1)
		self.thumb_view.connect("activate-cursor-item", self.handler)
		self.thumb_view.connect("item-activated", self.handler)
		self.thumb_view.show()
		self.swindow.add(self.thumb_view)
		self.swindow.show()
		
		self.menu = gtk.VBox()
		self.menu.set_size_request(185,100)
		self.menu.show()
		
		hbox = gtk.HBox()
		vbox = gtk.VBox()
				
		self.label = gtk.Label("Stuff")
		self.label.set_size_request(40, 40)
		self.label.show()
				
		
		hbox.set_homogeneous(False)
		
		vbox.pack_start(self.label, expand=False)
		vbox.pack_start(self.swindow, expand=True)
		hbox.pack_start(self.menu,expand=False)
		hbox.pack_start(vbox,expand=True)
		vbox.show()
		hbox.show()
		
		self.window.add(hbox)
        	self.window.show()
		
		self.database_view()
		self.menu_show()

	
	def menu_show(self):
		for widget in self.menu.get_children():
			self.menu.remove(widget)
		
		add_image = gtk.Image()
		add_image.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file_at_size("add.png", 48, 48))
		add_button = gtk.Button("Add Database")
		add_button.set_image(add_image)
		add_button.connect("clicked", self.on_button_add)
		add_image.show()
		add_button.show()
		
		save_image = gtk.Image()
		save_image.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file_at_size("save.png", 48, 48))
		save_button = gtk.Button("Save")
		save_button.set_image(save_image)
		save_button.connect("clicked", self.on_button_save)
		save_image.show()
		save_button.show()
		
		back_image = gtk.Image()
		back_image.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file_at_size("back.png", 48, 48))
		
		delete_image = gtk.Image()
		delete_image.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file_at_size("minus.png", 48, 48))
		
		add_def_image = gtk.Image()
		add_def_image.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file_at_size("add_default.png", 48, 48))
		
		delete_def_image = gtk.Image()
		delete_def_image.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file_at_size("minus_default.png", 48, 48))
		
		edit_image = gtk.Image()
		edit_image.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file_at_size("settings.png", 48, 48))
		
		if self.level == 0:
			exit_image = gtk.Image()
			exit_image.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file_at_size("exit.png", 48, 48))
			exit_button = gtk.Button("Exit")
			self.menu.pack_start(exit_button)
			exit_button.set_image(exit_image)
			exit_button.connect("clicked", self.destroy)
			exit_image.show()
			exit_button.show()
			
			self.menu.pack_start(save_button)
			self.menu.pack_start(add_button)
			
			search_image = gtk.Image()
			search_image.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file_at_size("search.png", 48, 48))
			search_button = gtk.Button("Search")
			self.menu.pack_start(search_button)
			search_button.set_image(search_image)
			search_button.connect("clicked", self.show_sdialog)
			search_image.show()
			search_button.show()
			
			"""edit_button = gtk.Button("Settings")
			self.menu.pack_start(edit_button)
			edit_button.set_image(edit_image)
			edit_button.connect("clicked", self.on_button_settings)
			edit_image.show()
			edit_button.show()"""
			
		if self.level == 1:
			back_button = gtk.Button("Back")
			self.menu.pack_start(back_button)
			back_button.set_image(back_image)
			back_button.connect("clicked", self.on_button_database_view)
			back_image.show()
			back_button.show()
			
			self.menu.pack_start(save_button)
			add_button.set_label("Add Category")
			add_image.show()
			self.menu.pack_start(add_button)
			
			delete_button = gtk.Button("Delete Database")
			self.menu.pack_start(delete_button)
			delete_button.set_image(delete_image)
			delete_button.connect("clicked", self.on_button_delete_database)
			delete_image.show()
			delete_button.show()
			
			
		if self.level == 2:
			back_button = gtk.Button("Back")
			self.menu.pack_start(back_button)
			back_button.set_image(back_image)
			back_button.connect("clicked", self.on_button_category_view)
			back_image.show()
			back_button.show()
			
			self.menu.pack_start(save_button)
			
			add_def_button = gtk.Button("Add Default")
			self.menu.pack_start(add_def_button)
			add_def_button.set_image(add_def_image)
			add_def_button.connect("clicked", self.on_add_default)
			add_def_image.show()
			add_def_button.show()
			
			delete_def_button = gtk.Button("Delete Default")
			self.menu.pack_start(delete_def_button)
			delete_def_button.set_image(delete_def_image)
			delete_def_button.connect("clicked", self.on_delete_default)
			delete_def_image.show()
			delete_def_button.show()
			
			
			add_button.set_label("Add Item")
			add_image.show()
			
			self.menu.pack_start(add_button)
			
			delete_button = gtk.Button("Delete Category")
			self.menu.pack_start(delete_button)
			delete_button.set_image(delete_image)
			delete_button.connect("clicked", self.on_button_delete_category)
			delete_image.show()
			delete_button.show()
			
	
	def on_button_delete_category(self, widget):
		self.show_cdialog("Delete %s?" % self.cur_category.get_name())
		
	def on_button_delete_database(self, widget):
		self.show_cdialog("Delete %s?" % self.cur_database.get_name())
	
	def on_button_database_view(self, widget):
		self.database_view()
		
	def on_button_category_view(self, widget):
		self.category_view(self.cur_database)
	
	
	def on_button_save(self, widget):
		self.dba.save()
		
	def on_button_settings(self, widget):
		pass
		#self.dba.save()
		
		
	def on_button_add(self, widget):
		self.show_dialog()

	def on_add_default(self, widget):
		self.show_adialog()
			
			
	def on_delete_default(self, widget):
		self.show_cdialog()
	
	def database_view(self):
		self.label.set_text("Stuff")
		self.level = 0
		self.model.clear()
		self.menu_show()
		for db in self.dba.database_list:
			pixbuf = gtk.gdk.pixbuf_new_from_file_at_size("database.png", 64, 64)
			self.model.append([db.get_name(), pixbuf]) 
 
		
	def category_view(self, db):
		self.level = 1
		self.model.clear()
		self.menu_show()
		for category in db.category_list:
			pixbuf = gtk.gdk.pixbuf_new_from_file_at_size("category.png", 64, 64)
			self.model.append([category.get_name(), pixbuf]) 
		self.update_label("Database: %s" % db.get_name())			
					
					
	def item_view(self, category):
		self.level = 2
		self.model.clear()
		self.menu_show()
		for item in category.item_list:
			pixbuf = gtk.gdk.pixbuf_new_from_file_at_size("item.png", 64, 64)
			self.model.append([item.get_name(), pixbuf]) 
		self.update_label("Datebase: %s, Category: %s" % (self.cur_database.get_name(), category.get_name()))
					
			
	def update_label(self, text):
		self.label.set_text(text)

		
	def destroy(self, widget, data=None):
		gtk.main_quit()
	
	
	def handler(self, widget, data=None):
		if self.level == 0:
			self.category_view(self.dba.database_list[data[0]])
			self.cur_database = self.dba.database_list[data[0]]
		elif self.level == 1:
			self.cur_category = self.cur_database.category_list[data[0]]
			self.item_view(self.cur_category)
		elif self.level == 2:
			ItemWindow.ItemWindow(self, self.cur_category.item_list[data[0]], self.dba, self.cur_category, self.cur_database)
			
	def set_category(self, category):
		self.cur_category = category
		
	def set_db(self, db):
		self.cur_database = db

	def show_dialog(self):
		titles = ['Add new database', 'Add new category','Add new item']
		msg = titles[self.level]
		self.entry = gtk.Entry()
		button1 = gtk.Button("Save")
		button2 = gtk.Button("Cancel")
		
		exit_image = gtk.Image()
		exit_image.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file_at_size("exit.png", 48, 48))
		button2.set_image(exit_image)
		exit_image.show()

		save_image = gtk.Image()
		save_image.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file_at_size("save.png", 48, 48))
		button1.set_image(save_image)
		save_image.show()
		
		
		label = gtk.Label(msg)
		self.dialog = gtk.Dialog() 
		hbox = gtk.HBox()
		
		hbox.pack_start(button1)
		hbox.pack_start(button2)
		hbox.show()
		
		self.dialog.vbox.pack_start(label)
		self.dialog.vbox.pack_start(self.entry)
		self.dialog.vbox.pack_start(hbox)
		#self.dialog.set_title(msg)
		
		button1.connect("clicked", self.on_button1_clicked)
		button1.show()
		
		button2.connect("clicked", self.on_button2_clicked)
		button2.show()
				
		label.show()
		
		self.entry.show()
		self.dialog.show()
		
    	def on_button1_clicked(self, widget):
		if len(self.entry.get_text()) > 0:
			if self.level == 0: 
				self.dba.database_add(self.entry.get_text())
				self.database_view()
			if self.level == 1: 
				self.cur_database.category_add(self.entry.get_text())
				self.category_view(self.cur_database)
			if self.level == 2: 
				self.cur_category.item_add(self.entry.get_text())
				self.item_view(self.cur_category)	
			self.dialog.destroy()
			
		
	def on_button2_clicked(self, widget):
		self.dialog.destroy()
		
		
	def show_cdialog(self, msg="?"):
		button1 = gtk.Button("Delete")
		button2 = gtk.Button("Cancel")
		
		delete_image = gtk.Image()
		delete_image.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file_at_size("minus.png", 48, 48))
		
		button1.set_image(delete_image)
		delete_image.show()
		
		exit_image = gtk.Image()
		exit_image.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file_at_size("exit.png", 48, 48))
		button2.set_image(exit_image)
		exit_image.show()
		
		
		hbox = gtk.HBox()
		
		hbox.pack_start(button1)
		hbox.pack_start(button2)
		hbox.show()
		
		label = gtk.Label(msg)
		self.cdialog = gtk.Dialog() 
		self.cdialog.vbox.pack_start(label)
		self.cdialog.vbox.pack_start(hbox)
		#self.dialog.set_title(msg)
		
		button1.connect("clicked", self.on_confirm)
		button1.show()
		
		button2.connect("clicked", self.on_cancel)
		button2.show()
				
		label.show()

		self.cdialog.show()
		
    	def on_confirm(self, widget):	
		self.cdialog.destroy()
		if self.level == 1:
			self.dba.database_delete(self.cur_database.get_name()) # delete database
			self.database_view()	
		if self.level == 2:
			self.cur_database.category_delete(self.cur_category.get_name())
			self.category_view(self.cur_database)
		if self.level == 3:
			self.cur_category.item_delete(self.cur_category.get_name())
			self.category_view(self.cur_database)
			
	def on_cancel(self, widget):
		self.cdialog.destroy()
		
	def show_sdialog(self, widget):
		button1 = gtk.Button("Search")
		button2 = gtk.Button("Cancel")
		
		search_image = gtk.Image()
		search_image.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file_at_size("search.png", 48, 48))
		
		button1.set_image(search_image)
		search_image.show()
		
		exit_image = gtk.Image()
		exit_image.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file_at_size("exit.png", 48, 48))
		button2.set_image(exit_image)
		exit_image.show()
		
		
		hbox = gtk.HBox()
		
		hbox.pack_start(button1)
		hbox.pack_start(button2)
		hbox.show()
		
		self.search_label = gtk.Label("Search Item:")
		
		self.search_entry = gtk.Entry()
		
		self.sdialog = gtk.Dialog() 
		self.sdialog.vbox.pack_start(self.search_label)
		self.sdialog.vbox.pack_start(self.search_entry)
		self.sdialog.vbox.pack_start(hbox)
		#self.dialog.set_title(msg)
		
		button1.connect("clicked", self.on_search_button)
		button1.show()
		
		button2.connect("clicked", self.on_search_cancel)
		button2.show()
				
		self.search_label.show()
		self.search_entry.show()

		self.sdialog.show()
		
    	def on_search_button(self, widget):
		found = False
		for db in self.dba.database_list:
			for category in db.category_list:
				for item in category.item_list:
					if self.search_entry.get_text() == item.get_name():
						ItemWindow.ItemWindow(self, item, self.dba, category, db)
						found = True
						self.sdialog.destroy()
		if not found:
			self.search_label.set_text("%s not found!" % self.search_entry.get_text())
		
			
	def on_search_cancel(self, widget):
		self.sdialog.destroy()
		
	def show_cdialog(self):
		button1 = gtk.Button("Delete")
		button2 = gtk.Button("Cancel")
		
		delete_image = gtk.Image()
		delete_image.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file_at_size("minus.png", 48, 48))
		
		button1.set_image(delete_image)
		delete_image.show()
		
		exit_image = gtk.Image()
		exit_image.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file_at_size("exit.png", 48, 48))
		button2.set_image(exit_image)
		exit_image.show()
		
		
		hbox = gtk.HBox()
		
		hbox.pack_start(button1)
		hbox.pack_start(button2)
		hbox.show()
		
		label = gtk.Label("Delete default field")
		combobox = gtk.combo_box_new_text()
		self.tmp_field = self.cur_category.defaults[0].get_name()
		for field in self.cur_category.defaults:
			combobox.append_text(field.get_name())
		combobox.connect('changed', self.changed_cb)
		
		self.cdialog = gtk.Dialog() 
		self.cdialog.vbox.pack_start(label)
		self.cdialog.vbox.pack_start(combobox)
		self.cdialog.vbox.pack_start(hbox)
		#self.dialog.set_title(msg)
		
		button1.connect("clicked", self.on_confirm)
		button1.show()
		
		button2.connect("clicked", self.on_cancel)
		button2.show()
				
		label.show()
		combobox.show()

		self.cdialog.show()
			
			
			
	def changed_cb(self, combobox):
		model = combobox.get_model()
		index = combobox.get_active()
		if index:
			self.tmp_field = model[index][0]
		return
	
	def on_confirm(self, widget):	
		self.cur_category.field_delete(self.tmp_field)
		self.cdialog.destroy()
			
			
	def on_cancel(self, widget):
		self.cdialog.destroy()
		
		
	def show_adialog(self):
		
		self.entry1 = gtk.Entry()
		self.entry2 = gtk.Entry()
		button1 = gtk.Button("Add")
		button2 = gtk.Button("Cancel")
		
		exit_image = gtk.Image()
		exit_image.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file_at_size("exit.png", 48, 48))
		button2.set_image(exit_image)
		exit_image.show()

		save_image = gtk.Image()
		save_image.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file_at_size("add.png", 48, 48))
		button1.set_image(save_image)
		save_image.show()
		
		
		label = gtk.Label("Add default field")
		label1 = gtk.Label("Name")
		label2 = gtk.Label("Type")
		label3 = gtk.Label("Value")
		
		self.adialog = gtk.Dialog() 
		hbox = gtk.HBox()
		
		hbox.pack_start(button1)
		hbox.pack_start(button2)
		hbox.show()
		
		combobox = gtk.combo_box_new_text()
		combobox.append_text("text")
		combobox.append_text("combobox")
		combobox.set_active(0)
		combobox.connect('changed', self.changed_type)
		self.tmp_type = "text"
		
		self.adialog.vbox.pack_start(label)
		self.adialog.vbox.pack_start(label1)
		self.adialog.vbox.pack_start(self.entry1)
		self.adialog.vbox.pack_start(label2)
		self.adialog.vbox.pack_start(combobox)
		self.adialog.vbox.pack_start(label3)
		self.adialog.vbox.pack_start(self.entry2)
		self.adialog.vbox.pack_start(hbox)
		#self.adialog.set_title(msg)
		
		button1.connect("clicked", self.on_confirm_add_default)
		button1.show()
		
		button2.connect("clicked", self.on_close_adialog)
		button2.show()
				
		label.show()
		label1.show()
		label2.show()
		label3.show()
		
		combobox.show()
		
		self.entry1.show()
		self.entry2.show()
		self.adialog.show()
		
	def changed_type(self, combobox):
		model = combobox.get_model()
		index = combobox.get_active()
		if index:
			self.tmp_type = model[index][0]
		return
		
    	def on_confirm_add_default(self, widget):
		if len(self.entry1.get_text()) > 0:
			self.cur_category.field_add(self.entry1.get_text(), self.tmp_type, self.entry2.get_text())#.split(', ')[0])
			self.adialog.destroy()
			
		
	def on_close_adialog(self, widget):	
		self.adialog.destroy()	
		
    	def main(self):
        	gtk.main()

