import pygtk
pygtk.require('2.0')
import gtk


class ItemWindow:
	def __init__(self, gui, item, dba, category, db):
		self.item = item
		self.dba = dba
		self.gui = gui
		self.db = db
		self.category = category
		self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
		self.window.set_title(self.item.get_name())
		self.swindow = gtk.ScrolledWindow()
		
		self.swindow.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
		#self.window.connect("destroy", self.destroy)
		self.menu = gtk.VBox()
		self.menu.set_size_request(185,100)
		self.menu.show()
		
		hbox = gtk.HBox()
		vbox = gtk.VBox()
		self.sbox = gtk.VBox()
		
		label = gtk.Label(self.item.get_name())
		#self.text = gtk.TextView()
		#if self.item.field_present("Text"):
		#	self.text.get_buffer().set_text(self.item.field_select("Text").get_value()) ## DEMO!!!!
		hbox.pack_start(self.menu,expand=False)
		hbox.pack_start(vbox,expand=True)
		self.menu.set_size_request(150,100)
		vbox.pack_start(label,expand=False)
		vbox.pack_start(self.swindow)
		#vbox.pack_start(self.text)
		self.widgets = []
		
		
		for field in self.item.field_list:
			ibox = gtk.HBox()
			name = gtk.Label(field.get_name())
			
			if field.get_type() == "combobox":
				self.value = gtk.combo_box_new_text()
				self.combobox_init(field)
			
			#if field.get_type() == "text": 
			else:
				self.value = gtk.Entry()
				self.value.set_text(field.get_value())
				
			self.widgets.append(self.value)
			
			#elif field.get_type() == "combobox":
			#	self.value = gtk.combo_box_new_text()
			#	self.combobox_init(field)
				
			ibox.pack_start(name,expand=False)
			name.set_size_request(120, 40)
			ibox.pack_start(self.value)
			name.show()
			self.value.show()
			name.show()
			ibox.show()
			
			self.sbox.pack_start(ibox,expand=False)
			
		self.swindow.add_with_viewport(self.sbox)
		self.swindow.show()
		self.window.add(hbox)
		
		hbox.show()
		vbox.show()
		self.sbox.show()
		label.show()
		
		#self.text.show()
		self.menu.show()
		self.window.show()
		self.menu_show()
		
	def fields_refresh(self):
		self.widgets = []
	
		for widget in self.sbox.get_children():
			self.sbox.remove(widget)
			
		for field in self.item.field_list:
			ibox = gtk.HBox()
			name = gtk.Label(field.get_name())
			
			if field.get_type() == "combobox":
				self.value = gtk.combo_box_new_text()
				self.combobox_init(field)
			
			#if field.get_type() == "text": 
			else:
				self.value = gtk.Entry()
				self.value.set_text(field.get_value())
				
			self.widgets.append(self.value)
			
			#elif field.get_type() == "combobox":
			#	self.value = gtk.combo_box_new_text()
			#	self.combobox_init(field)
				
			ibox.pack_start(name,expand=False)
			name.set_size_request(120, 50)
			ibox.pack_start(self.value)
			name.show()
			self.value.show()
			name.show()
			ibox.show()
	
			self.sbox.pack_start(ibox,expand=False)
		
		
	#def combobox_init(self, field):
	#	if len(field.get_valid_values()) > 1:
	#		for value in field.get_valid_values():
	#			self.value.append_text(value)
	#	else:
	#		self.value.append_text(field.get_valid_values()[0])
	#	self.value.set_active(field.get_valid_value_index(field.get_value()))
			
	def combobox_init(self, field):
		for value in field.get_valid_values():
			self.value.append_text(value)
		if len(field.get_value()) > 0:
			self.value.set_active(field.get_valid_value_index(field.get_value()))	
			
	def read_fields(self):
		i = 0
		for field in self.item.field_list:
		#for widget in self.widgets:
			widget = self.widgets[i]
			if field.get_type() == "text":
				try:
					field.set_value(widget.get_text())
				except:
					pass
					#field.set_value("")
					#print self.widgets[i].get_text()
			else:
				#widget = self.widgets[i]
				model = widget.get_model()
				index = widget.get_active()
				if index:
					#pass
					field.set_value(model[index][0])
			i = i + 1
			
	def on_button_save(self, widget):
		self.read_fields()
		self.dba.save()
	
	def on_button_close(self, widget):
		self.window.hide()
		
	def on_button_edit(self, widget):
		self.window.hide()
		
	def on_button_add(self, widget):
		self.show_dialog()
	
	def on_button_delete(self, widget):
		self.show_cdialog()
		
	def on_button_delete_item(self, widget):
		self.show_idialog()
		
	def on_button_move(self, widget):
		self.show_mdialog()
	
	def menu_show(self):
		for widget in self.menu.get_children():
			self.menu.remove(widget)
		
		
		exit_image = gtk.Image()
		exit_image.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file_at_size("exit.png", 48, 48))
		exit_button = gtk.Button("Close")
		self.menu.pack_start(exit_button)
		exit_button.set_image(exit_image)
		exit_button.connect("clicked", self.on_button_close)
		exit_image.show()
		exit_button.show()
		
		save_image = gtk.Image()
		save_image.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file_at_size("save.png", 48, 48))
		save_button = gtk.Button("Save")
		self.menu.pack_start(save_button)
		save_button.set_image(save_image)
		save_button.connect("clicked", self.on_button_save)
		save_image.show()
		save_button.show()
		
		add_image = gtk.Image()
		add_image.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file_at_size("add.png", 48, 48))
		add_button = gtk.Button("Add Field")
		self.menu.pack_start(add_button)
		add_button.set_image(add_image)
		add_button.connect("clicked", self.on_button_add)
		add_image.show()
		add_button.show()
		
		delete_image = gtk.Image()
		delete_image.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file_at_size("minus.png", 48, 48))
		delete_button = gtk.Button("Delete Field")
		self.menu.pack_start(delete_button)
		delete_button.set_image(delete_image)
		delete_button.connect("clicked", self.on_button_delete)
		delete_image.show()
		delete_button.show()
		
		move_image = gtk.Image()
		move_image.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file_at_size("move.png", 48, 48))
		move_button = gtk.Button("Move Item")
		self.menu.pack_start(move_button)
		move_button.set_image(move_image)
		move_button.connect("clicked", self.on_button_move)
		move_image.show()
		move_button.show()
		
		delete_image = gtk.Image()
		delete_image.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file_at_size("minus.png", 48, 48))
		delete_item_button = gtk.Button("Delete Item")
		self.menu.pack_start(delete_item_button)
		delete_item_button.set_image(delete_image)
		delete_item_button.connect("clicked", self.on_button_delete_item)
		delete_image.show()
		delete_item_button.show()
		
		#edit_image = gtk.Image()
		#edit_image.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file_at_size("settings.png", 48, 48))
		#edit_button = gtk.Button("Edit Item")
		#self.menu.pack_start(edit_button)
		#edit_button.set_image(edit_image)
		#edit_button.connect("clicked", self.on_button_edit)
		#edit_image.show()
		#edit_button.show()
		
	def show_cdialog(self, msg="?"):
		button1 = gtk.Button("Delete")
		button2 = gtk.Button("Cancel")
		
		delete_image = gtk.Image()
		delete_image.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file_at_size("minus.png", 48, 48))
		
		button1.set_image(delete_image)
		delete_image.show()
		
		exit_image = gtk.Image()
		exit_image.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file_at_size("exit.png", 48, 48))
		button2.set_image(exit_image)
		exit_image.show()
		
		
		hbox = gtk.HBox()
		
		hbox.pack_start(button1)
		hbox.pack_start(button2)
		hbox.show()
		
		label = gtk.Label("Delete Field")
		combobox = gtk.combo_box_new_text()
		self.tmp_field = self.item.field_list[0].get_name()
		for field in self.item.field_list:
			combobox.append_text(field.get_name())
		combobox.connect('changed', self.changed_cb)
		
		self.cdialog = gtk.Dialog() 
		self.cdialog.vbox.pack_start(label)
		self.cdialog.vbox.pack_start(combobox)
		self.cdialog.vbox.pack_start(hbox)
		#self.dialog.set_title(msg)
		
		button1.connect("clicked", self.on_confirm)
		button1.show()
		
		button2.connect("clicked", self.on_cancel)
		button2.show()
				
		label.show()
		combobox.show()

		self.cdialog.show()
			
			
			
	def changed_cb(self, combobox):
		model = combobox.get_model()
		index = combobox.get_active()
		if index:
			self.tmp_field = model[index][0]
		return
	
	def on_confirm(self, widget):	
		self.item.field_delete(self.tmp_field)
		self.cdialog.destroy()
		self.fields_refresh()
			
			
	def on_cancel(self, widget):
		self.cdialog.destroy()
		

	def show_idialog(self, msg="?"):
		button1 = gtk.Button("Delete")
		button2 = gtk.Button("Cancel")
		
		delete_image = gtk.Image()
		delete_image.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file_at_size("minus.png", 48, 48))
		
		button1.set_image(delete_image)
		delete_image.show()
		
		exit_image = gtk.Image()
		exit_image.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file_at_size("exit.png", 48, 48))
		button2.set_image(exit_image)
		exit_image.show()
		
		
		hbox = gtk.HBox()
		
		hbox.pack_start(button1)
		hbox.pack_start(button2)
		hbox.show()
		
		label = gtk.Label("Delete %s?" % self.item.get_name())
		self.idialog = gtk.Dialog() 
		self.idialog.vbox.pack_start(label)
		self.idialog.vbox.pack_start(hbox)
		#self.dialog.set_title(msg)
		
		button1.connect("clicked", self.on_item_confirm)
		button1.show()
		
		button2.connect("clicked", self.on_item_cancel)
		button2.show()
				
		label.show()

		self.idialog.show()
	
	def on_item_confirm(self, widget):	
		self.idialog.destroy()
		self.category.item_delete(self.item.get_name())
		self.gui.item_view(self.category)
		self.window.destroy()
			
			
	def on_item_cancel(self, widget):
		self.idialog.destroy()
	
	def show_dialog(self):
		
		self.entry1 = gtk.Entry()
		self.entry2 = gtk.Entry()
		button1 = gtk.Button("Add")
		button2 = gtk.Button("Cancel")
		
		exit_image = gtk.Image()
		exit_image.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file_at_size("exit.png", 48, 48))
		button2.set_image(exit_image)
		exit_image.show()

		save_image = gtk.Image()
		save_image.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file_at_size("add.png", 48, 48))
		button1.set_image(save_image)
		save_image.show()
		
		
		label = gtk.Label("Add new field")
		label1 = gtk.Label("Name")
		label2 = gtk.Label("Type")
		label3 = gtk.Label("Value")
		
		self.dialog = gtk.Dialog() 
		hbox = gtk.HBox()
		
		hbox.pack_start(button1)
		hbox.pack_start(button2)
		hbox.show()
		
		combobox = gtk.combo_box_new_text()
		combobox.append_text("text")
		combobox.append_text("combobox")
		combobox.set_active(0)
		combobox.connect('changed', self.changed_type)
		self.tmp_type = "text"
		
		self.dialog.vbox.pack_start(label)
		self.dialog.vbox.pack_start(label1)
		self.dialog.vbox.pack_start(self.entry1)
		self.dialog.vbox.pack_start(label2)
		self.dialog.vbox.pack_start(combobox)
		self.dialog.vbox.pack_start(label3)
		self.dialog.vbox.pack_start(self.entry2)
		self.dialog.vbox.pack_start(hbox)
		#self.dialog.set_title(msg)
		
		button1.connect("clicked", self.on_button1_clicked)
		button1.show()
		
		button2.connect("clicked", self.on_button2_clicked)
		button2.show()
				
		label.show()
		label1.show()
		label2.show()
		label3.show()
		
		combobox.show()
		
		self.entry1.show()
		self.entry2.show()
		self.dialog.show()
		
	def changed_type(self, combobox):
		model = combobox.get_model()
		index = combobox.get_active()
		if index:
			self.tmp_type = model[index][0]
		return
		
    	def on_button1_clicked(self, widget):
		if len(self.entry1.get_text()) > 0:
			if self.tmp_type == "combobox":
				value = self.entry2.get_text().split(', ')
			else:
				value = self.entry2.get_text()
			self.item.field_add(self.entry1.get_text(), self.tmp_type, value)
			self.dialog.destroy()
			self.fields_refresh()
			
		
	def on_button2_clicked(self, widget):	
		self.dialog.destroy()
		
		
	def show_mdialog(self, msg="?"):
		button1 = gtk.Button("Move")
		button2 = gtk.Button("Cancel")
		
		move_image = gtk.Image()
		move_image.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file_at_size("move.png", 48, 48))
		
		button1.set_image(move_image)
		move_image.show()
		
		exit_image = gtk.Image()
		exit_image.set_from_pixbuf(gtk.gdk.pixbuf_new_from_file_at_size("exit.png", 48, 48))
		button2.set_image(exit_image)
		exit_image.show()
		
		
		hbox = gtk.HBox()
		
		hbox.pack_start(button1)
		hbox.pack_start(button2)
		hbox.show()
		
		label1 = gtk.Label("Database")
		self.combobox1 = gtk.combo_box_new_text()
		
		self.tmp_db = self.db.get_name()
		i = 0
		for db in self.dba.database_list:
			self.combobox1.append_text(db.get_name())
			if db.get_name() == self.db.get_name():
				self.combobox1.set_active(i)
			i = i + 1
			
		self.combobox1.connect('changed', self.changed_db)
		
		label2 = gtk.Label("Category")
		self.combobox2 = gtk.combo_box_new_text()
		self.tmp_categoy = self.category.get_name()

		i = 0
		for category in self.db.category_list:
			self.combobox2.append_text(category.get_name())
			if category.get_name() == self.category.get_name():
				self.combobox2.set_active(i)
				self.tmp_category = self.category.get_name()
			i = i + 1
			
		#self.combobox2.connect('changed', self.changed_cat)
		
		self.mdialog = gtk.Dialog() 
		self.mdialog.vbox.pack_start(label1)
		self.mdialog.vbox.pack_start(self.combobox1)
		self.mdialog.vbox.pack_start(label2)
		self.mdialog.vbox.pack_start(self.combobox2)
		self.mdialog.vbox.pack_start(hbox)
		#self.dialog.set_title(msg)
		
		button1.connect("clicked", self.on_confirm_move)
		button1.show()
		
		button2.connect("clicked", self.on_cancel_move)
		button2.show()
				
		label1.show()
		label2.show()
		self.combobox1.show()
		self.combobox2.show()
		

		self.mdialog.show()

	
	def changed_db(self, combobox):
		model = combobox.get_model()
		index = combobox.get_active()
		self.combobox2.get_model().clear()
		#if index:
		self.tmp_db = model[index][0]
		for category in self.dba.database_select(self.tmp_db).category_list:
			
			self.combobox2.append_text(category.get_name())
		self.combobox2.set_active(0)
		if not self.dba.database_select(self.tmp_db).is_empty():
			self.tmp_category = self.dba.database_select(self.tmp_db).category_list[0].get_name()
			
		#else:
		#	for category in self.db.category_list:
		#		self.combobox2.append_text(category.get_name())
		#		print category.get_name()
		#	self.combobox2.set_active(0)
		#	if not self.db.is_empty():
		#		self.tmp_category = self.db.category_list[0].get_name()
		#self.changed_cat(self.combobox2)
		return
	
	def on_confirm_move(self, widget):
		if not self.dba.database_select(self.tmp_db).is_empty():
			model = self.combobox2.get_model()
			index = self.combobox2.get_active()	
			if index:
				newcategory =  model[index][0]
			else:
				newcategory = self.tmp_category
				
			newdb =  self.dba.database_select(self.tmp_db)
			newcategory = newdb.category_select(newcategory)
			if newcategory.item_move_here(self.item):
				self.category.item_delete(self.item.get_name())
					
				self.gui.set_category(newcategory)
				self.gui.set_db(newdb)
				self.gui.item_view(newcategory)
				self.db = newdb
				self.category = newcategory

		#self.item.field_delete(self.tmp_field)
				self.mdialog.destroy()

		#self.fields_refresh()
			
			
	def on_cancel_move(self, widget):
		self.mdialog.destroy()
		
	